'##################################################################################
'# Autor:                                                                         #
'# Vorname        Guido                                                           #
'# Nachnahme      Scheidat                                                        #
'# Strasse                                                                        #
'# PLZ Ort                                                                        #
'# e-mail:                                                                        #
'# Programmtitel: Nachbau der Melodieklingel Aus Fa 4 / 86 Mit modernen Bauteilen #
'# Dateinahme:    Melodieklingel_nach_Guido_Scheidat.bas                          #
'# Prgrammbeschreibung:   Melodieklingel   -   Guido Scheidat                     #
'#    Nachbau Der Melodieklingel Aus Fa 4 / 86 mit modernen Bauteilen             #
'#    bernahme aller Melodien aus der "Funkamateur"                              #
'#    Controler: ATmega8                                                          #
'#    Intern/ extern 8 Mhz, Achtung Fusebits aendern !!!                          #
'#    Pin 4(pd2 / Int0) - Klingeltaster gegen Masse ueber Optokoppler             #
'#    Pin 15(pb1 / Oc1a) - Ausgang Zum Lautsprecher                               #
'# Geaendert durch Dieter Aschmann: 08.06:2013                                    #
'#    Schaltplanprojekt mit TARGET 3001 V16 mit Platine erstellt (V1.0)           #
'#    Pin 23 PC0 gibt an LED ein Lied ist aktiv aus (LED leuchtet)                #
'#    Pin 24 PC1 + 2 +3 selektiert per Schalter drei Liedertabellen               #
'#    "Lied", "VIP", "Christm" dritte Liedtabelle                                 #
'#    01.07.2013: Bug gefunden und beseitigt, siehe Quelltexteintrag              #
'# Aufbau der Tne in der Liedtabelle:                                            #
'# Bit                                                                            #
'# 7  6  5  4  3  2  1  0                                                         #
'#                                                                                #
'# Tonhhe (Bit 3,2,1,0)                                                          #
'# 0  -  Pause (kein Ton)                                                         #
'# 1  -  c'    261,63 Hz                                                          #
'# 2  -  cis'  277,18 Hz                                                          #
'# 3  -  d'    293,66 Hz                                                          #
'# 4  -  dis'  311,11 Hz                                                          #
'# 5  -  e'    329,63 Hz                                                          #
'# 6  -  f'    349,22 Hz                                                          #
'# 7  -  fis'  369,99 Hz                                                          #
'# 8  -  g'    392,00 Hz                                                          #
'# 9  -  gis'  415,33 Hz                                                          #
'# A  -  a'    440,00 Hz                                                          #
'# B  -  b'    466,15 Hz                                                          #
'# C  -  h'    493,89 Hz                                                          #
'# D  -  c"    523,22 Hz                                                          #
'# E  -  cis"  554,40 Hz                                                          #
'# F  -  d"    587,37 Hz                                                          #
'#                                                                                #
'# Tonlnge in Achtelnoten (Bit 6,5,4)                                            #
'# 0  -  1/8                                                                      #
'# 1  -  1/4                                                                      #
'# 2  -  3/8                                                                      #
'# 3  -  1/2                                                                      #
'# 4  -  5/8                                                                      #
'# 5  -  3/4                                                                      #
'# 6  -  7/8                                                                      #
'# 7  -  1                                                                        #
'#                                                                                #
'# Stoppbit (Bit 7)                                                               #
'# Wird an jedem Liedende gesetzt.                                                #
'##################################################################################
'
'*** Direktiven ***
$regfile = "m8def.dat"                                      'Die Anweisung bestimmt Controllertyp, hier AVR ATmega 8
$crystal = 8000000                                          'Die Frequenz des verwendeten Quarzes
$hwstack = 40                                               'Rcksprungadressen nach SUB, FUNCTION, GOSUB und ISR
$swstack = 32                                               'Speicher fuer Variable reserviert
$framesize = 32                                             'Fuer Conversionen reservierter Speicher und Stringvariablen
'$sim                                                                                     'Fuer Simulation entfernt Waitstates, danach auskommentieren.
'$prog &HFF , &HF4 , &HD9 , &H00                                                          'Verwende Sorgfalt das der Chip auch alle Fusebytes untersttzt.
'wird mit STK500 erledigt...
'*** Variablen ***

Dim Viertel As Byte
Dim I As Byte
Dim Lang As Byte
Dim Aktton As Byte                                          'Aktuelles Tonbyte
Dim Enderr As Bit
Dim Liedcount As Integer

'*** Konstanten ***

Const Speed = 4                                             'darf nicht 0 sein
Liedcount = 0                                               'Notenzaehler
Lang = 1                                                    'Notenlaenge
Enderr = 0                                                  'Liedende
Viertel = 1                                                 'Viertelnote
Set Portd.2                                                 'Pull-up ein PD2 ext. Interrupt 0
Config Portb.1 = Input                                      'SOUNDOFF
Config Portc.0 = Output                                     'LED- Ausgabe
Led Alias Portc.0                                           'und ueber Port C.0 ausgeben
Set Portc.1                                                 'Pull-up C1 ein
Config Portc.1 = Input                                      'PORTC1 Pin 24 als Eingang definiert
Select Alias Pinc.1                                         'PORTC1 Pin 24 als Select bezeichnet (Jumper)
Set Portc.2                                                 'Pull-up C2 ein
Config Portc.2 = Input                                      'PORTC2 Pin 25 als Eingang definiert
Select1 Alias Pinc.2                                        'PORTC2 Pin 25 als Select1 bezeichnet (Jumper)
Set Portc.3                                                 'Pull-up C3 ein
Config Portc.3 = Input                                      'PORTC3 Pin 26 als Eingang definiert
Select2 Alias Pinc.3                                        'PORTC3 Pin 26 als Select2 bezeichnet (Jumper)
'~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
'*** Initialisierungen ***
'----------------------------------------------------------------------------


'*** Timer 1 einstellen
Set Tccr1b.cs10                                             'Vorteiler auf 1
Reset Tccr1b.cs11
Reset Tccr1b.cs12

'Toggle OC1A on Compare Match
Reset Tccr1a.com1a1
Set Tccr1a.com1a0

'Waveform Generation Mode --> Mode 4; CTC
'WGM13 = 0
'WGM12 = 1
'WGM11 = 0
'WGM10 = 0
Reset Tccr1b.wgm13                                          'Bit loeschen im Timercontrolregister 1B
Set Tccr1b.wgm12                                            'Bit setzen im Timercontrolregister 1B
Reset Tccr1a.wgm10                                          'Bit loeschen im Timercontrolregister 1A
Reset Tccr1a.wgm11                                          'Bit loeschen im Timercontrolregister 1A

'*** Timer 0 einstellen
   Config Timer0 = Timer , Prescale = 1024                  'Konfiguriere Timer0
   On Timer0 Isr_timer0                                     'verzweige bei Timer0-berlauf zu ISR_Timer0
   Timer0 = 256 - 243                                       'Timer0 Zeit fr 1/8 Note / 4
   Enable Timer0                                            'Schalte den Timer0 ein

'*** externen Interrupt 0 einstellen
   Config Int0 = Low Level                                  'Configuriere Int0 Auf Low Level
   On Int0 Isr_int0                                         'Springe zu ISR_Int0
   Enable Int0                                              'Einschalten von Interrupt Int0

'*** Behandlung von Interrupts
   Enable Interrupts                                        'Einschalten aller der Interrupts

'----------------------------- Unterprogramme -------------------------------
'
'----------------------------------------------------------------------------
'
'----------------------------------------------------------------------------
'----------------------------- Hauptprogramm --------------------------------
'....Hauptprogramm     --  es gibt fast kein Hauptprogramm, da alles ueber Interrupts gesteuert wird
 Do
      If Liedcount > 0 Then Led = 1                         'Lied gespielt LED an                                                     'Sonst aus
      If Aktton.7 = 1 Then Led = 0                          'Liedende erreicht, LED aus
      Waitms 200                                            '100ms Pause
 Loop
 End

'----------------------------------------------------------------------------

'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'++++++++++++++++++++++++++++++++++ ISR  ++++++++++++++++++++++++++++++++++++
 '*** Interrupt-Routine fr Timer 0
   Isr_timer0:                                              'ISR von Timer0
      Viertel = Viertel - 1
      If Viertel = 0 Then
         Viertel = Speed
         Lang = Lang - 1
         If Lang = 0 Then
            If Enderr = 1 Then                              'Timer / Counter0 Overflow Interrupt Disable
               Disable Timer0                               'schalte den Timer0 aus
               Config Portb.1 = Input                       'SOUNDOFF
               Enable Int0                                  'INT0 erlauben
            Else
                      'Aktton = Lookup(liedcount , Lied), war die Ursache fuer Spiel des 1. Tones der Tabelle Lied.
                      'Danach war der Ablauf der gewaehlten Tabelle in Ordnung, bis zum neuen Tabellenende... .
                      'Korrekt erst nach Einfuegen der drei Abfragen der einzelnen Liedtabellen... .
                      If Select = 0 Then Aktton = Lookup(liedcount , Lied)       'Lied 1...26 gewaehlt
                      If Select1 = 0 Then Aktton = Lookup(liedcount , Vip)       'Lied 27...68 gewaehlt
                      If Select2 = 0 Then Aktton = Lookup(liedcount , Christm)       'Weihnachtslieder gewaehlt
            If Aktton.7 = 1 Then Enderr = 1                 'Liedende gefunden
               Lang = Aktton                                'Tonlnge ermitteln
               Shift Lang , Right , 4                       'Division durch 16
               Lang = Lang And &H07
               Lang = Lang + 1
               Aktton = Aktton And &H0F
               If Aktton = 0 Then
                  Config Portb.1 = Input                    'SOUNDOFF
               Else
                  Aktton = Aktton - 1
                  Reset Tccr1b.cs10                         'CTC aus
                  Shift Aktton , Left , 1                   'Multiplikation mit 2
                  Ocr1ah = Lookup(aktton , Tone)            'Tonhoehe lesen High
                  Aktton = Aktton + 1
                  Ocr1al = Lookup(aktton , Tone)            'Tonhoehe lesen Low
                  Tcnt1l = 0                                'Zhler soll bei 0 beginnen
                  Tcnt1h = 0
                  Set Tccr1b.cs10                           'CTC ein
                  Config Portb.1 = Output                   'SOUNDON
               End If                                       'Beginn Liedvorwahl
                     Liedcount = Liedcount + 1              'nchste Note
                     If Select = 0 Then Aktton = Lookup(liedcount , Lied)       'Lied 1...26 gewaehlt
                     If Select1 = 0 Then Aktton = Lookup(liedcount , Vip)       'Lied 27...68 gewaehlt
                     If Select2 = 0 Then Aktton = Lookup(liedcount , Christm)       'Weihnachtslieder gewaehlt
               End If
                     If Aktton = &HFF Then Liedcount = 0    'Liedende erreicht ?
         End If
      End If
   Return

'*** Interrupt-Routine fr externen Interrupt 0
   Isr_int0:                                                'INT0 ausschalten
      Disable Int0                                          'External Interrupt Request 0 Disable
                                                                                          'Tastenentprellung und Sturmklingelsperre
      I = 0
      While I < 30                                          'Taste muss mindestens 30 ms gedrckt sein
         If Pind.2 = 0 Then
            Waitms 1                                        '1ms Pause
            I = I + 1                                       'Zaehler ms
         Else                                               'sonst von vorn Zaehler = 0
            I = 0
         End If
      Wend

      I = 0
      While I < 30
         If Pind.2 = 1 Then                                 'Taste muss mindestens 30 ms losgelassen sein
            Waitms 1                                        '1ms Pause
            I = I + 1                                       'Zaehler ms
         Else                                               'sonst von vorn Zaehler = 0
            I = 0
         End If
      Wend
                                                                                          'Taste wurde erfolgreich gedrckt und losgelassen
                                                                                          'Jetzt kann die nchste Melodie gespielt werden
      Viertel = 1
      Lang = 1
      Enderr = 0
      Enable Timer0
   Return
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
'*************************** Tonleiter **************************************
'Timerwerte fr die enspr. Tonhoehen in Hz
   Tone:
   Data 59 , 184                                            ' c'     261,63 Hz
   Data 56 , 94                                             ' cis'   277,18 Hz
   Data 53 , 52                                             ' d'     293,66 Hz
   Data 50 , 56                                             ' dis'   311,11 Hz
   Data 47 , 102                                            ' e'     329,63 Hz
   Data 44 , 189                                            ' f'     349,22 Hz
   Data 42 , 58                                             ' fis'   369,99 Hz
   Data 39 , 219                                            ' g'     392,00 Hz
   Data 37 , 158                                            ' gis'   415,33 Hz
   Data 35 , 130                                            ' a'     440,00 Hz
   Data 33 , 132                                            ' b'     466,15 Hz
   Data 31 , 162                                            ' h'     493,89 Hz
   Data 29 , 220                                            ' c''    523,22 Hz
   Data 28 , 46                                             ' cis''  554,40 Hz
   Data 26 , 153                                            ' d''    587,37 Hz

''***  Liedertabellen   *****************************************************
'****************************** 1. Liedtabelle ******************************
   Lied:
' -- Titel #1 -----------------------------------------------------------------
Data &H03 , &H00 , &H05 , &H00 , &H07 , &H00 , &H08 , &H00 , &H0A , &H00 , &H0C
Data &H00 , &H3A , &H08 , &H00 , &H05 , &H00 , &H3E , &H0A , &H00 , &H07 , &H00
Data &HAF

' -- Titel #2 -----------------------------------------------------------------
Data &H35 , &H00 , &H2A , &H00 , &H02 , &H05 , &H10 , &H05 , &H10 , &H85

' -- Titel #3 -----------------------------------------------------------------
Data &H03 , &H00 , &H05 , &H00 , &H37 , &H3A , &H0E , &H20 , &H1C , &H10
Data &H2C , &H00 , &HA7

' -- Titel #4 -----------------------------------------------------------------
Data &H47 , &H00 , &H06 , &H00 , &H07 , &H00 , &H0F , &H00 , &H07 , &H00 , &H0E
Data &H00 , &H0C , &H20 , &H0C , &H20 , &H9C

' -- Titel #5 -----------------------------------------------------------------
Data &H0A , &H00 , &H2F , &H10 , &H1E , &H10 , &H0C , &H0A , &H10 , &HA7

' -- Titel #6 -----------------------------------------------------------------
Data &H53 , &H17 , &H3A , &H3F , &H3C , &H1F , &H1C , &HBA

' -- Titel #7 -----------------------------------------------------------------
Data &H13 , &H20 , &H15 , &H20 , &H17 , &H00 , &H1A , &H1C , &H00 , &H1A , &H1F
Data &H20 , &H1C , &H20 , &H1A , &HB7

' -- Titel #8 -----------------------------------------------------------------
Data &H17 , &H18 , &H3A , &H27 , &H00 , &H27 , &H00 , &H37 , &H95

' -- Titel #9 -----------------------------------------------------------------
Data &H33 , &H08 , &H00 , &H0A , &H00 , &H3C , &H3F , &H3C , &H3A , &HB8

' -- Titel #10 ----------------------------------------------------------------
Data &H48 , &H00 , &H0A , &H00 , &H08 , &H00 , &H06 , &H00 , &H25 , &H00 , &H21
Data &H00 , &HB1

' -- Titel #11 ----------------------------------------------------------------
Data &H45 , &H00 , &H03 , &H00 , &H02 , &H00 , &H05 , &H00 , &H0A , &H00 , &H0C
Data &H00 , &H5E , &H10 , &HBA

' -- Titel #12 ----------------------------------------------------------------
Data &H0A , &H00 , &H08 , &H00 , &H0A , &H00 , &H08 , &H00 , &H07 , &H20 , &HB3

' -- Titel #13 ----------------------------------------------------------------
Data &H03 , &H00 , &H03 , &H00 , &H25 , &H00 , &H23 , &H00 , &H28 , &H00 , &H47
Data &H20 , &H03 , &H00 , &H03 , &H00 , &H25 , &H00 , &H23 , &H00 , &H2A , &H00
Data &HC8

' -- Titel #14 ----------------------------------------------------------------
Data &H46 , &H00 , &H14 , &H13 , &H14 , &H36 , &H3F , &H3B , &HA6

' -- Titel #15 ----------------------------------------------------------------
Data &H15 , &H12 , &H50 , &H12 , &H23 , &H15 , &H0E , &H20 , &H0E , &H20 , &HBA

' -- Titel #16 ----------------------------------------------------------------
Data &H28 , &H00 , &H03 , &H00 , &H23 , &H10 , &H38 , &H00 , &H25 , &H00 , &H05
Data &H00 , &H25 , &H40 , &H27 , &H00 , &H08 , &H00 , &H2A , &H10 , &H27 , &H10
Data &H28 , &H00 , &H0C , &H00 , &HB8

' -- Titel #17 ----------------------------------------------------------------
Data &H4A , &H00 , &H07 , &H10 , &H0A , &H10 , &H07 , &H10 , &H0A , &H10 , &H08
Data &H10 , &HA8

' -- Titel #18 ----------------------------------------------------------------
Data &H0C , &H00 , &H0B , &H00 , &H0C , &H20 , &H0C , &H00 , &H0B , &H00 , &H0C
Data &H20 , &H0C , &H00 , &H0B , &H00 , &H0C , &H20 , &H0A , &H20 , &H98

' -- Titel #19 ----------------------------------------------------------------
Data &H03 , &H00 , &H03 , &H00 , &H28 , &H00 , &H2C , &H00 , &H08 , &H00 , &H08
Data &H00 , &H2A , &H00 , &H2D , &H00 , &H03 , &H00 , &H07 , &H00 , &H3A , &H00
Data &H0C , &H00 , &H2A , &H00 , &HA8

' -- Titel #20 ----------------------------------------------------------------
Data &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H07 , &H00 , &H0A , &H00 , &H28
Data &H00 , &H08 , &H00 , &H0C , &H00 , &H1A , &H00 , &H0C , &H0A , &H00 , &H08
Data &H00 , &HA7

' -- Titel #21 ----------------------------------------------------------------
Data &H21 , &H00 , &H46 , &H00 , &H08 , &H00 , &H0B , &H00 , &H0A , &H00 , &H08
Data &H00 , &H2D , &H00 , &HAD

' -- Titel #22 ----------------------------------------------------------------
Data &H28 , &H00 , &H4D , &H00 , &H08 , &H00 , &H25 , &H00 , &H26 , &H00 , &H48
Data &H00 , &H0A , &H00 , &HA8

' -- Titel #23 ----------------------------------------------------------------
Data &H23 , &H00 , &H4F , &H00 , &H0E , &H00 , &H2F , &H00 , &H2C , &H00 , &H4D
Data &H00 , &H0C , &H00 , &H2D , &H00 , &H27 , &H00 , &H0A , &H00 , &H18 , &H6A
Data &H00 , &H6A , &H00 , &H0A , &H00 , &H3C , &H30 , &H0A , &H00 , &H2C , &H00
Data &H0A , &H00 , &H0C , &H00 , &H2A , &H00 , &H09 , &H00 , &HB8

' -- Titel #24 ----------------------------------------------------------------
Data &H0C , &H20 , &H2A , &H20 , &H07 , &H00 , &H05 , &H00 , &H03 , &H00 , &H2C
Data &H00 , &H2B , &H00 , &HAC

' -- Titel #25 ----------------------------------------------------------------
Data &H07 , &H00 , &H05 , &H00 , &H03 , &H00 , &H05 , &H00 , &H07 , &H00 , &H05
Data &H00 , &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H0C , &H20 , &H27 , &H00
Data &H8C

' -- Titel #26 ----------------------------------------------------------------
Data &H03 , &H00 , &H05 , &H00 , &H27 , &H00 , &H27 , &H00 , &H08 , &H00 , &H05
Data &H00 , &H1C , &H0A , &H00 , &HAA
Data &HFF                                                   'Endekennzeichen Liedertabelle

'##############################################################################
'******************************* 2. Liedtabelle *******************************
Vip:
' -- Titel #27 ----------------------------------------------------------------
Data &H23 , &H00 , &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H2A
Data &H00 , &H0C , &H00 , &H0A , &H00 , &H27 , &H00 , &HA3 ,

' -- Titel #28 ----------------------------------------------------------------
Data &H3F , &H3E , &H3C , &H3A , &H3C , &H18 , &H17 , &H25 , &H00 , &HA3

' -- Titel #29 ----------------------------------------------------------------
Data &H00 , &H23 , &H00 , &H48 , &H00 , &H03 , &H00 , &H28 , &H00 , &H0C , &H00
Data &H0C , &H00 , &H68 , &H00 , &H23 , &H00 , &H08 , &H00 , &H0C , &H00 , &H2A
Data &H00 , &H23 , &H00 , &H23 , &H00 , &H05 , &H00 , &H07 , &H00 , &HE8

' -- Titel #30 ----------------------------------------------------------------
Data &H03 , &H00 , &H23 , &H00 , &H07 , &H00 , &H2A , &H00 , &H0F , &H00 , &H4A
Data &H00 , &H27 , &H00 , &H03 , &H00 , &H25 , &H00 , &H05 , &H00 , &H15 , &H07
Data &H00 , &H05 , &H00 , &HC3

' -- Titel #31 ----------------------------------------------------------------
Data &H6F , &H00 , &H2C , &H00 , &H28 , &H00 , &H2C , &H00 , &H2F , &H00 , &H3F
Data &H2D , &H00 , &H2A , &H00 , &H30 , &H28 , &H00 , &H08 , &H00 , &H08 , &H00
Data &H28 , &H00 , &H28 , &H00 , &H28 , &H00 , &H08 , &H00 , &H08 , &H00 , &H2A
Data &H00 , &H07 , &H00 , &H05 , &H00 , &H23 , &H00 , &H30 , &H6F , &H00 , &H2C
Data &H00 , &H28 , &H00 , &H2C , &H00 , &H2F , &H00 , &H3F , &H2D , &H00 , &HAA

' -- Titel #32 ----------------------------------------------------------------
Data &H00 , &H2A , &H00 , &H2E , &H00 , &H2C , &H00 , &H10 , &H05 , &H00 , &H07
Data &H00 , &H05 , &H00 , &H07 , &H00 , &H09 , &H00 , &HAA

' -- Titel #33 ----------------------------------------------------------------
Data &H03 , &H00 , &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H2C
Data &H00 , &H2A , &H00 , &H10 , &H08 , &H00 , &H07 , &H00 , &H05 , &H00 , &H13
Data &H07 , &H00 , &H1A , &H07 , &H00 , &HE5

' -- Titel #34 ----------------------------------------------------------------
Data &H25 , &H00 , &H4A , &H00 , &H0C , &H00 , &H2C , &H00 , &H2C , &H00 , &H6A
Data &H00 , &H29 , &H00 , &H2A , &H00 , &H1C , &H0E , &H00 , &H2F , &H00 , &H1E
Data &H0C , &H00 , &H2A , &H00 , &HEC

' -- Titel #35 ----------------------------------------------------------------
Data &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &H07 , &H00 , &H05 , &H00 , &H23
Data &H00 , &H25 , &H00 , &H25 , &H00 , &H23 , &H00 , &H10 , &H0A , &H00 , &H0C
Data &H00 , &H0A , &H00 , &H0C , &H00 , &H0E , &H00 , &H2F , &H00 , &H2E , &H00
Data &H2C , &H00 , &HAA

' -- Titel #36 ----------------------------------------------------------------
Data &H26 , &H00 , &H2A , &H00 , &H2D , &H00 , &H28 , &H00 , &H08 , &H00 , &H05
Data &H00 , &H21 , &H00 , &H26 , &H00 , &H2A , &H00 , &H2D , &H00 , &HE8

' -- Titel #37 ----------------------------------------------------------------
Data &H03 , &H00 , &H07 , &H00 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H27
Data &H00 , &H23 , &H00 , &H05 , &H00 , &H03 , &H00 , &H05 , &H00 , &H07 , &H00
Data &H25 , &H00 , &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H27
Data &H00 , &H23 , &H00 , &HE5

' -- Titel #38 ----------------------------------------------------------------
Data &H06 , &H00 , &H06 , &H00 , &H2B , &H00 , &H2B , &H00 , &H0F , &H00 , &H0B
Data &H00 , &HE6

' -- Titel #39 ----------------------------------------------------------------
Data &H12 , &H05 , &H00 , &H1A , &H02 , &H00 , &H25 , &H00 , &H23 , &H00 , &H27
Data &H00 , &H27 , &H00 , &H15 , &H09 , &H00 , &H1C , &H0F , &H00 , &H1E , &H0C
Data &H00 , &HEA

' -- Titel #40 ----------------------------------------------------------------
Data &H24 , &H00 , &H49 , &H00 , &H08 , &H00 , &H26 , &H00 , &H24 , &H00 , &H46
Data &H00 , &H04 , &H00 , &HA1 , &H23 , &H00 , &H48 , &H00 , &H08 , &H00 , &H28
Data &H00 , &H28 , &H00 , &H23 , &H00 , &H25 , &H00 , &H63 , &H00 , &H68 , &H00
Data &H2F , &H00 , &H2F , &H00 , &HEC

' -- Titel #41 ----------------------------------------------------------------
Data &H21 , &H00 , &H46 , &H00 , &H08 , &H00 , &H2A , &H00 , &H1B , &H0F , &H00
Data &H6D , &H00 , &H30 , &H16 , &H0A , &H00 , &H2D , &H00 , &H2D , &H00 , &H2B
Data &H00 , &H1D , &H0B , &H00 , &HEA

' -- Titel #42 ----------------------------------------------------------------
Data &H2B , &H00 , &H0D , &H00 , &H0D , &H00 , &H0D , &H00 , &H0D , &H00 , &H0D
Data &H00 , &H0D , &H00 , &H0D , &H00 , &H0D , &H00 , &H2D , &H00 , &H1C , &H0A
Data &H00 , &H28 , &H00 , &H30 , &H2A , &H00 , &H0A , &H00 , &H0A , &H00 , &H2C
Data &H00 , &H0C , &H00 , &H0C , &H00 , &H0D , &H00 , &H0D , &H00 , &H8B

' -- Titel #43 ----------------------------------------------------------------
Data &H26 , &H00 , &H28 , &H00 , &H26 , &H00 , &H2B , &H00 , &H2A , &H00 , &H68
Data &H00 , &H26 , &H00 , &H2A , &H00 , &H2A , &H00 , &H2A , &H00 , &H2F , &H00
Data &H2D , &H00 , &H2D , &H00 , &H6B , &H00 , &H2A , &H00 , &H2A , &H00 , &H2A
Data &H00 , &H2B , &H00 , &H2A , &H00 , &HE8

' -- Titel #44 ----------------------------------------------------------------
Data &H23 , &H00 , &H48 , &H00 , &H08 , &H00 , &H28 , &H00 , &H0C , &H00 , &H0A
Data &H00 , &H38 , &H25 , &H00 , &H23 , &H00 , &H28 , &H00 , &H25 , &H00 , &H21
Data &H00 , &H03 , &H00 , &H07 , &H00 , &H2A , &H00 , &HE8

' -- Titel #45 ----------------------------------------------------------------
Data &H23 , &H00 , &H28 , &H00 , &H28 , &H00 , &H2A , &H00 , &H2F , &H00 , &H6C
Data &H00 , &H2C , &H00 , &H2D , &H00 , &H2A , &H00 , &H28 , &H00 , &H2A , &H00
Data &H27 , &H00 , &HE8

' -- Titel #46 ----------------------------------------------------------------
Data &H05 , &H00 , &H28 , &H00 , &H05 , &H00 , &H06 , &H00 , &H05 , &H00 , &H03
Data &H00 , &H21 , &H00 , &H05 , &H00 , &H05 , &H00 , &H03 , &H00 , &H01 , &H00
Data &H23 , &H00 , &H06 , &H00 , &H06 , &H00 , &H05 , &H00 , &H03 , &H00 , &H25
Data &H00 , &H08 , &H00 , &HAD

' -- Titel #47 ----------------------------------------------------------------
Data &H6C , &H00 , &H6A , &H00 , &H2D , &H00 , &H17 , &H05 , &H00 , &H23 , &H00
Data &H23 , &H00 , &H28 , &H00 , &H28 , &H00 , &H2A , &H00 , &H2A , &H00 , &HEC

' -- Titel #48 ----------------------------------------------------------------
Data &H2D , &H00 , &H2D , &H00 , &H2D , &H00 , &H28 , &H00 , &H2C , &H00 , &H0D
Data &H00 , &H2A , &H00 , &H68 , &H00 , &H2D , &H00 , &H2C , &H00 , &H2A , &H00
Data &H28 , &H00 , &H2A , &H00 , &H16 , &H15 , &H23 , &H00 , &HE1

' -- Titel #49 ----------------------------------------------------------------
Data &H01 , &H00 , &H06 , &H00 , &H08 , &H00 , &H0A , &H00 , &H0B , &H00 , &H2D
Data &H00 , &H0F , &H00 , &H0B , &H00 , &H0A , &H00 , &H10 , &H08 , &H00 , &H10
Data &HA6

' -- Titel #50 ----------------------------------------------------------------
Data &H13 , &H07 , &H00 , &H2A , &H00 , &H2A , &H00 , &H27 , &H00 , &H23 , &H00
Data &H15 , &H03 , &H00 , &H15 , &H07 , &H00 , &H25 , &H00 , &H13 , &H07 , &H00
Data &H2A , &H00 , &H2A , &H00 , &H27 , &H00 , &H23 , &H00 , &HE5

' -- Titel #51 ----------------------------------------------------------------
Data &H03 , &H00 , &H28 , &H00 , &H08 , &H00 , &H18 , &H07 , &H00 , &H08 , &H00
Data &H2A , &H00 , &H0A , &H00 , &H2A , &H00 , &H0A , &H00 , &H2C , &H00 , &H0C
Data &H00 , &H1F , &H0D , &H00 , &H0A , &H00 , &HC8

' -- Titel #52 ----------------------------------------------------------------
Data &H0C , &H00 , &H0F , &H00 , &H0C , &H00 , &H0F , &H00 , &H0C , &H00 , &H0D
Data &H00 , &H0A , &H00 , &H0D , &H00 , &H0A , &H00 , &H0C , &H00 , &H08 , &H00
Data &H0F , &H00 , &H0C , &H00 , &H0A , &H00 , &H0F , &H00 ,

' -- Titel #53 ----------------------------------------------------------------
Data &H8F , &H23 , &H00 , &H2C , &H00 , &H0C , &H00 , &H0C , &H00 , &H2C , &H00
Data &H2A , &H00 , &H68 , &H00 , &H28 , &H00 , &H23 , &H00 , &H2D , &H00 , &H0D
Data &H00 , &H0D , &H00 , &H0D , &H00 , &H0C , &H00 , &H0F , &H00 , &H0C , &H00
Data &HEA

' -- Titel #54 ----------------------------------------------------------------
Data &H28 , &H00 , &H2D , &H00 , &H08 , &H00 , &H05 , &H00 , &H28 , &H00 , &H06
Data &H00 , &H03 , &H00 , &H68 , &H00 , &H25 , &H00 , &H10 , &H08 , &H00 , &H28
Data &H00 , &H0A , &H00 , &H08 , &H00 , &H26 , &H00 , &H05 , &H00 , &H03 , &H00
Data &HE1

' -- Titel #55 ----------------------------------------------------------------
Data &H46 , &H00 , &H17 , &H06 , &H00 , &H07 , &H00 , &H39 , &H0E , &H00 , &H02
Data &H00 , &H10 , &H42 , &H00 , &H17 , &H02 , &H00 , &H04 , &H00 , &H16 , &H07
Data &H00 , &H06 , &H00 , &HA4

' -- Titel #56 ----------------------------------------------------------------
Data &H06 , &H00 , &H06 , &H00 , &H49 , &H00 , &H06 , &H00 , &H26 , &H00 , &H29
Data &H00 , &H30 , &H06 , &H00 , &H09 , &H00 , &H2E , &H00 , &H4D , &H00 , &H0B
Data &H00 , &H3B , &H29 , &H00 , &H04 , &H00 , &H06 , &H00 , &H27 , &H00 , &H24
Data &H00 , &H04 , &H00 , &H06 , &H00 , &H27 , &H00 , &H30 , &H04 , &H00 , &H07
Data &H00 , &H0D , &H00 , &H0B , &H00 , &H29 , &H00 , &H2D , &H00 , &HAE

' -- Titel #57 ----------------------------------------------------------------
Data &H01 , &H00 , &H05 , &H00 , &H48 , &H00 , &H08 , &H00 , &H08 , &H00 , &H0A
Data &H00 , &H0C , &H00 , &H6D , &H00 , &H28 , &H00 , &H0A , &H00 , &H08 , &H00
Data &H48 , &H00 , &H06 , &H00 , &H06 , &H00 , &H0A , &H00 , &H06 , &H00 , &HE5

' -- Titel #58 ----------------------------------------------------------------
Data &H03 , &H00 , &H05 , &H00 , &H07 , &H00 , &H08 , &H00 , &H0A , &H00 , &H0C
Data &H00 , &H2A , &H00 , &H08 , &H00 , &H05 , &H00 , &H2E , &H00 , &H0A , &H00
Data &H07 , &H00 , &HAF

' -- Titel #59 ----------------------------------------------------------------
Data &H03 , &H00 , &H07 , &H00 , &H4A , &H00 , &H0F , &H00 , &H0A , &H00 , &H07
Data &H00 , &H08 , &H00 , &H05 , &H00 , &H67 , &H00 , &H25 , &H00 , &H25 , &H00
Data &H27 , &H00 , &H07 , &H00 , &H0A , &H00 , &H28 , &H00 , &H08 , &H00 , &H0C
Data &H00 , &HEA

' -- Titel #60 ----------------------------------------------------------------
Data &H03 , &H00 , &H07 , &H00 , &H4A , &H00 , &H0C , &H00 , &H2A , &H00 , &H28
Data &H00 , &H57 , &H05 , &H00 , &H23 , &H00 , &H2A , &H00 , &H2C , &H00 , &H2A
Data &H00 , &H28 , &H00 , &H27 , &H00 , &HE5

' -- Titel #61 ----------------------------------------------------------------
Data &H06 , &H00 , &H26 , &H00 , &H06 , &H00 , &H26 , &H00 , &H06 , &H00 , &H46
Data &H00 , &H23 , &H00 , &H06 , &H00 , &H2B , &H00 , &H0B , &H00 , &H2B , &H00
Data &H0B , &H00 , &H3F , &H0D , &H00 , &H1B , &H0A , &H00 , &H08 , &H00 , &H26
Data &H00 , &H06 , &H00 , &H16 , &H08 , &H00 , &H0A , &H00 , &HEB

' -- Titel #62 ----------------------------------------------------------------
Data &H0E , &H00 , &H0C , &H00 , &H2A , &H00 , &H25 , &H00 , &H25 , &H00 , &H2A
Data &H00 , &H27 , &H00 , &H27 , &H00 , &H27 , &H00 , &H10 , &H0A , &H00 , &H29
Data &H00 , &H29 , &H00 , &H29 , &H00 , &H27 , &H00 , &HE5

' -- Titel #63 ----------------------------------------------------------------
Data &H01 , &H00 , &H2A , &H00 , &H0A , &H00 , &H1A , &H08 , &H00 , &H0A , &H00
Data &H2B , &H00 , &H08 , &H00 , &H25 , &H00 , &H01 , &H00 , &H26 , &H00 , &H06
Data &H00 , &H16 , &H05 , &H00 , &H06 , &H00 , &HE8

' -- Titel #64 ----------------------------------------------------------------
Data &H03 , &H00 , &H08 , &H00 , &H03 , &H00 , &H28 , &H00 , &H2C , &H00 , &H0A
Data &H00 , &H0A , &H00 , &H08 , &H00 , &H03 , &H00 , &H08 , &H00 , &H03 , &H00
Data &H28 , &H00 , &H2C , &H00 , &H0F , &H00 , &H0F , &H00 , &H0C , &H00 , &H0A
Data &H00 , &H08 , &H00 , &H0A , &H00 , &H1C , &H1F , &H0D , &H00 , &H0C , &H00
Data &H0A , &H00 , &H0A , &H00 , &HA8

' -- Titel #65 ----------------------------------------------------------------
Data &H21 , &H00 , &H26 , &H00 , &H06 , &H00 , &H06 , &H00 , &H2A , &H00 , &H0A
Data &H00 , &H0A , &H00 , &H6F , &H00 , &H6D , &H00 , &H70 , &H6D , &H00 , &H4D
Data &H00 , &H0D , &H00 , &HED

' -- Titel #66 ----------------------------------------------------------------
Data &H21 , &H00 , &H26 , &H00 , &H26 , &H00 , &H08 , &H00 , &H08 , &H00 , &H2A
Data &H00 , &H2A , &H00 , &H10 , &H0B , &H00 , &H2D , &H00 , &H1F , &H0D , &H00
Data &H1B , &H0A , &H00 , &H3A , &HA8

' -- Titel #67 ----------------------------------------------------------------
Data &H03 , &H00 , &H03 , &H00 , &H28 , &H00 , &H2C , &H00 , &H0A , &H00 , &H08
Data &H00 , &H48 , &H00 , &H03 , &H00 , &H03 , &H00 , &H03 , &H00 , &H28 , &H00
Data &H2C , &H00 , &H0A , &H00 , &H08 , &H00 ,

' -- Titel #68 ----------------------------------------------------------------
Data &HCA , &H2C , &H00 , &H0C , &H00 , &H0F , &H00 , &H6A , &H00 , &H2C , &H00
Data &H0C , &H00 , &H0F , &H00 , &H6A , &H00 , &H2D , &H00 , &H2D , &H00 , &H2C
Data &H00 , &H2F , &H00 , &H6A , &H00 , &HA8
Data &HFF                                                   'Endekennzeichen Liedertabelle
'##############################################################################
'********************** 3. Liedtabelle Weihnachtslieder ***********************
Christm:
'Musi1:
Data &H11 , &H00 , &H28 , &H00 , &H08 , &H00 , &H38 , &H00 , &H10 , &H1A , &H00
Data &H2C , &H00 , &H0C , &H00 , &H3C , &H10 , &H1C , &H00 , &H1A , &H00 , &H1C
Data &H00 , &H3D , &H00 , &H37 , &H00 , &H3A , &H00 , &HB8
'Musi2
Data &H18 , &H00 , &H18 , &H00 , &H18 , &H00 , &H13 , &H00 , &H1C , &H00 , &H1C
Data &H00 , &H1C , &H00 , &H18 , &H00 , &H1F , &H00 , &H1F , &H00 , &H1D , &H00
Data &H1D , &H00 , &H1C , &H00 , &H1C , &H00 , &HBA
'Musi3
Data &H3C , &H00 , &H1D , &H00 , &H3F , &H00 , &H1F , &H00 , &H3D , &H00 , &H1C
Data &H00 , &H3A , &H00 , &H1A , &H00 , &H38 , &H00 , &H1A , &H00 , &H3C , &H00
Data &H1C , &H00 , &H3D , &H00 , &H1C , &H00 , &HCA
'Musi4
Data &H0F , &H0D , &H00 , &H0C , &H00 , &H0D , &H00 , &H1F , &H00 , &H1C , &H00
Data &H18 , &H00 , &H1A , &H00 , &H3C , &H00 , &H0C , &H00 , &H0A , &H00 , &H08
Data &H00 , &H0A , &H00 , &H1C , &H00 , &H18 , &H00 , &H13 , &H00 , &H17 , &H00
Data &HB8
'Musi5
Data &H38 , &H00 , &H25 , &H00 , &H26 , &H00 , &H08 , &H00 , &H0A , &H00 , &H08
Data &H00 , &H0A , &H00 , &H38 , &H10 , &H46 , &H00 , &H23 , &H00 , &H28 , &H00
Data &HC5
'Musi6
Data &H38 , &H00 , &H38 , &H00 , &H18 , &H1A , &H00 , &H18 , &H16 , &H00 , &H35
Data &H00 , &H35 , &H00 , &H45 , &H30 , &H36 , &H00 , &H36 , &H00 , &H16 , &H18
Data &H00 , &H16 , &H15 , &H00 , &H33 , &H00 , &H33 , &H00 , &HC3
'Musi7
Data &H18 , &H00 , &H08 , &H00 , &H3D , &H00 , &H3C , &H00 , &H3A , &H00 , &H38
Data &H00 , &H3D , &H00 , &H35 , &H00 , &H38 , &H00 , &H3F , &H00 , &H3C , &H00
Data &HFD
'Musi8
Data &H31 , &H00 , &H31 , &H00 , &H38 , &H00 , &H38 , &H00 , &H3A , &H00 , &H3A
Data &H00 , &H78 , &H00 , &H36 , &H00 , &H36 , &H00 , &H35 , &H00 , &H35 , &H00
Data &H73 , &H00 , &HF1
'Musi9
Data &H11 , &H00 , &H11 , &H00 , &H15 , &H00 , &H38 , &H00 , &H15 , &H00 , &H18
Data &H00 , &H1D , &H00 , &H1A , &H00 , &H38 , &H00 , &H15 , &H00 , &H18 , &H00
Data &H1A , &H00 , &H18 , &H00 , &H36 , &H00 , &H33 , &H00 , &H18 , &H00 , &H18
Data &H00 , &HD5
'Musi10
Data &H78 , &H00 , &H7A , &H00 , &H58 , &H00 , &H16 , &H00 , &H35 , &H36 , &H00
Data &H78 , &H00 , &H7A , &H00 , &H58 , &H00 , &H16 , &H00 , &H35 , &H36 , &H00
Data &H78 , &H00 , &H78 , &H00 , &H7A , &H00 , &H3C , &H00 , &H3D , &H00 , &H7C
Data &H00 , &H7A , &H00 , &H78 , &HB8
Data &HFF                                                   'Endekennzeichen Liedertabelle
'##############################################################################
'End Program